//MIDP 2.0
import javax.microedition.media.*;
import javax.microedition.media.control.*;
import java.io.*;

public class midiPlayer {
 public boolean enabled=false;
 private InputStream input;
 private Player player;
 private VolumeControl vc;

 public midiPlayer (String url) { 
  enabled=true;
  try {
   input = getClass().getResourceAsStream (url);
   player = Manager.createPlayer (input, "audio/midi");
  }
  catch (IOException zxz) { 
   enabled=false; 
   //System.out.println (zxz); 
   return; 
  }
  catch (MediaException zmz) { 
   enabled=false; 
   //System.out.println (zmz); 
   return; 
  }
 }

 public int setLevel (int level) {
  if (enabled) {
   vc=(VolumeControl)player.getControl("VolumeControl");
   vc.setLevel (10+10*level);
   return vc.getLevel ();
  }
  else return 0;
 }

 public void play () {
  if (enabled) {
   try { 
    player.start (); 
    setLevel (options.volume);
   }
   catch (MediaException zmz) { 
    enabled=false;
    //System.out.println (zmz); 
   }
  }
 }

 public void stop () {
  if (enabled) player.close ();
  enabled = false;
 }

}