import javax.microedition.lcdui.*;

class matrixClock {
 private int n,width,height,x0,h;

 public matrixClock (int scrwidth) {
  n=4*scrwidth/39; // 
  width=13*n/2; // 
  x0=(scrwidth-width)/2; //  
  height=n*2+3; // 
  h=n/4; // 
  //System.out.println ("n="+n+" width="+width+" x0="+x0+" height="+height+" h="+h);//!!!
 }

 public int getHeight () {
  return height;
 }

 private void hor0 (Graphics g, int x, int y) {
  g.fillRect (x+h,y,n-2*h,h);
  g.fillTriangle (x,y,x+h,y,x+h,y+h);
  g.fillTriangle (x+n-h,y,x+n-h,y+h,x+n,y);
 }

 private void ver1 (Graphics g, int x, int y) {
  g.fillRect (x,y+h,h,n-2*h);
  g.fillTriangle (x,y,x,y+h,x+h,y+h);
  g.fillTriangle (x,y+n-h,x,y+n,x+h,y+n-h);
 }

 private void ver2 (Graphics g, int x, int y) {
  g.fillRect (x-h,y+h,h,n-2*h);
  g.fillTriangle (x,y,x-h,y+h,x,y+h);
  g.fillTriangle (x,y+n-h,x,y+n,x-h,y+n-h);
 }

 private void hor1 (Graphics g, int x, int y) {
  g.fillRect (x+h,y-h/2,n-2*h,h);
  g.fillTriangle (x,y,x+h,y-h/2,x+h,y+h/2);
  x+=n;
  g.fillTriangle (x,y,x-h,y-h/2,x-h,y+h/2);
 }

 private void hor2 (Graphics g, int x, int y) {
  g.fillRect (x+h,y-h,n-2*h,h);
  g.fillTriangle (x,y,x+h,y,x+h,y-h);
  g.fillTriangle (x+n,y,x+n-h,y,x+n-h,y-h);
 }

 private void digit (Graphics g, int x, int y, int d) {
  if (!((d==1) || (d==4))) hor0 (g,x,y+1);
  if ((d==0) || (d>3) && (d<7) || (d==8) || (d==9)) ver1 (g,x,y+2);
  if ((d<5) || (d>6)) ver2 (g,x+n,y+2);
  if (!((d==0) || (d==1) || (d==7))) hor1 (g,x,y+n+2);
  if ((d==0) || (d==2) || (d==6) || (d==8)) ver1 (g,x,y+n+2);
  if (d!=2) ver2 (g,x+n,y+n+2);
  if (!((d==1) || (d==4) || (d==7))) hor2 (g,x,y+2*n+3);
 }

 public void draw (Graphics g, int top, int hour, int min) {
  digit (g,x0,top,hour/10);
  digit (g,x0+n+n/2,top,hour%10);
  int x1=x0+3*n;
  g.fillArc (x1,top+height/4,4,4,0,360);
  g.fillArc (x1,top+5*height/8,4,4,0,360);
  x1+=n/2+4;
  digit (g,x1,top,min/10);
  x1+=n+n/2;
  digit (g,x1,top,min%10);
 }

}